// This file is made available under Elastic License 2.0.
// This file is based on code available under the Apache license here:
//   https://github.com/apache/incubator-doris/blob/master/fe/fe-core/src/test/java/org/apache/doris/persist/StorageInfoTest.java

// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.

package com.starrocks.persist;

import org.junit.Assert;
import org.junit.Test;

public class StorageInfoTest {
    @Test
    public void test() {
        StorageInfo info = new StorageInfo();
        Assert.assertEquals(-1, info.getClusterID());
        Assert.assertEquals(0, info.getImageJournalId());

        info = new StorageInfo(10, 20);
        Assert.assertEquals(10, info.getClusterID());
        Assert.assertEquals(20, info.getImageJournalId());

        info.setClusterID(100);
        info.setImageJournalId(200);

        Assert.assertEquals(100, info.getClusterID());
        Assert.assertEquals(200, info.getImageJournalId());
    }
}
